<template>
	<a-drawer
		:title="formData.id ? '编辑入库贷款' : '增加入库贷款'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId">
				<a-select v-model:value="formData.depotId" placeholder="请选择企业客户" :options="depotIdOptions" @change="checkDepot(formData.depotId)"/>
			</a-form-item>
			<a-form-item label="贷款合同号：" name="contractCode">
				<a-input v-model:value="formData.contractCode" placeholder="请输入贷款合同号" disabled/>
			</a-form-item>
			<a-form-item label="放款状态：" name="loanState">
				<a-radio-group v-model:value="formData.loanState" :options="loanStateOptions"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotLoanOrderForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotLoanOrderApi from '@/api/biz/depotLoanOrderApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import depotGrainInfoApi from '@/api/biz/depotGrainInfoApi'
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const loanStateOptions = ref([])
const depotIdOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	console.log(record)
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	} else {
		dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
			depotIdOptions.value = data
		})
	}
	loanStateOptions.value = tool.dictList('放款状态')
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 关闭抽屉
const checkDepot = (depotId) => {
	depotGrainInfoApi.depotGrainInfoDetail({"id": depotId}).then((data) => {
		formData.value.contractCode = data.contractCode
	})
}
// 默认要校验的
const formRules = {
	depotId: [required('请输入')],
	contractCode: [required('请输入')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			formDataParam.loanState = JSON.stringify(formDataParam.loanState)
			depotLoanOrderApi
				.depotLoanOrderSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
